import turtle as t
import time
def draw():
    '''
    画棋盘
    '''
    # 重新开始
    t.up()
    t.goto(-150, 170)
    t.write('重新开始', font=('', 15))
    for i in range(2):
        t.up()
        t.goto(-150, 50-i*100)
        t.down()
        t.fd(300)
    t.seth(-90)
    for i in range(2):
        t.up()
        t.goto(-50+i*100, 150)
        t.down()
        t.fd(300)
    t.up()
def victory(x, y, num):
    '''
    x：int表示现在下的棋子的横坐标
    y：int表示现在下的棋子的纵坐标
    num：int表示下棋者，1表示红棋2表示蓝棋
    '''
    global zb_, stop
    # 判断是否取得胜利
    # 将图中的位置映射到zb_这个列表中, r表示行，c表示列
    if y == 100:
        r = 0
    elif y == 0:
        r = 1
    else:
        r = 2
    if x == -100:
        c = 0
    elif x == 0:
        c = 1
    else:
        c = 2
    # 将棋子映射到列表中
    zb_[r][c] = num
    print(zb_)
    # 判断周围是否赢棋 只有棋子的总数大于等于五颗才判断是否有人获得胜利
    if len(zb) < 4:
        return False
    # 判断棋的周围是否有三颗相同的棋
    for i in range(4): # 先判断行，在列然后斜着
        # 用于判断是否有三个一样的
        num_qz = [(r, c)]
        for j in range(2): # 根据坐标分为两种情况
            r_ = r
            c_ = c
            # 第一次判断左边有几颗相同的棋
            while zb_[r_][c_] == num:
                if i == 0 and j == 0:
                    r_ -=  1
                elif i == 0 and j == 1:
                    r_ += 1
                elif i == 1 and j == 0:
                    c_ -= 1
                elif i == 1 and j == 1:
                    c_ += 1
                elif i == 2 and j == 0:
                    r_ -= 1
                    c_ -= 1
                elif i == 2 and j == 1:
                    r_ += 1
                    c_ += 1
                elif i == 3 and j == 0:
                    r_ += 1
                    c_ -= 1 
                else:
                    r_ -= 1
                    c_ += 1
                if r_ > 2 or r_ < 0 or c_ > 2 or c_ < 0:
                    # 遍历完了整个棋盘
                    break
                if zb_[r_][c_] == num:
                    num_qz.append((r_, c_))
        if len(num_qz) == 3:
            stop = True
            return True, num, num_qz
    return False                

    
def panduan(x, y):
    x_ = x
    y_ = y
    # 判断x和y在哪个范围
    if -150 <= y < -50:
        y_ = -100
    elif -50 <= y < 50:
        y_ = 0
    elif 50<= y < 150:
        y_ = 100

    if -150< x <= -50:
        x_ = -100
    elif -50< x <= 50:
        x_ = 0
    elif 50 < x <= 150:
        x_ = 100
    if x_ == x or y_ == y:
        return False
    else:
        return x_, y_


def func(x, y):
    '''
    鼠标点击事件
    '''
    print(x, y)
    global num, zb, stop
    print(15)
    if (-174 < x < -72 and 174 < y < 188):
        print(454)
        t.home()  # 要保证笔头朝向正东
        stop = False
        t.clear()
        start()
        return
    if not stop:
        if len(zb) == 9:
            return
        res = panduan(x, y)
        if res:
            x = res[0]
            y = res[1]
            if (x, y) in zb:
                return
            t.goto(x, y)
            if num % 2 == 0: 
                print(111)
                t.dot(80, 'red')
                # 判断是否胜利
                res = victory(x, y, 1)
            else:
                t.dot(80, 'blue')
                res = victory(x, y, 2)
            zb.append((x, y))
            # 判断是否胜利
            if res:
                # t.clear()
                t.goto(-125, -25)
                if res[1] == 1:
                    # t.color('red')
                    t.write('红棋获得胜利', font=('楷体', 30))
                else:
                    # t.color('blue')
                    t.write('蓝棋获得胜利', font=('楷体', 30))
            elif len(zb) == 9:
                # t.clear()
                t.goto(-90, -25)
                t.write('伯仲之间', font=('楷体', 30))
                stop = True
            num += 1

def start():
    global stop, zb, zb_, num
    stop = False
    # 定义一个点击次数用于判断点击了几次，用于下不同的棋子
    num = 0
    # 定义一个列表存放下过的坐标点
    zb = []
    # 定义一个二位列表用于判断是否取得胜利1表示红色2表示蓝色
    zb_ = [[0, 0, 0], [0, 0, 0], [0, 0, 0]]

    # 定义屏幕对象
    draw()

t.tracer(False)
t.ht()
start()
screen = t.Screen()
screen.onscreenclick(func)
t.mainloop()
t.tracer(True)

